
#include "string.h"
#include "dict.h"

/* Global variables */
extern Dictionary endTags;
extern Dictionary handlerDict;

/*
 * Tag Handlers are functions that return void,
 * and take four arguements,
 * 1) the tag string, which they should alter to
 * the parsed text.
 * 2) an arg string, not containing any registered endTags
 * 3) any registered endTag
 * 4) a dictionary of data for the tag, from dictForTag()
 * The keys are of type const char * and the values of type String
 * The prototype for a handler is:
 * void handler(String ts,String as,String et,Dictionary td);
 */
 
 /* The values in endTags should also be of type String. */
 
void initializeHtmlParsingLibrary();

String parseHtml(const char *fileName);

String mainHtmlParser(const char *stopStr);

void handleTag(String tagString);

void handlePlainText(String plainText);

Dictionary dictForTag(String tagString);

String stringForTagDict(Dictionary tagDict);